import json

import Apifon.sdk.Mookee as mookee
from Apifon.sdk.Exception.ApifonRestError import ApifonRestError
from Apifon.sdk.Model.Request.ListRequestBuilder import ListRequestBuilder
from Apifon.sdk.Model.Request.OAuthConfigurationBuilder import OAuthConfigurationBuilder
from Apifon.sdk.Resource.Helpers.ListType import ListType
from Apifon.sdk.Resource.ListResource import ListResource



def remove_nones(var):
    for i in list(var):
        if var[i] is None or ((isinstance(var[i], dict) or isinstance(var[i], list)) and not bool(var[i])):
            var.pop(i)
        elif type(var[i]) is dict:
            remove_nones(var[i])
        elif type(var[i]) is list:
            var[i] = [x for x in var[i] if x != 20]
            for j in var[i]:
                if type(j) is dict:
                    remove_nones(j)


def print_json(output):
    json_string = json.dumps(output, default=lambda o: o.__dict__, sort_keys=True, indent=4)
    json_dict = json.loads(json_string)
    remove_nones(json_dict)
    json_string = json.dumps(json_dict, default=lambda o: o.__dict__, sort_keys=True, indent=4)
    print(json_string)


Mookee = mookee.Mookee.get_instance()
listResource = ListResource()

client_id = "your_oauth_client_id"
client_secret = "your_oauth_secret_key"

oauth_identifier_list = "your_identifier_list"

def create_simple_list():
    listRequestBuilder = ListRequestBuilder.get_add_request_builder(ListType.advanced.value, "My Simple OAuth List",
                                                                    '30')
    listRequest = listRequestBuilder.build()

    print("Sending Request to Endpoint: /services/api/list")
    print("------ List Request Body ------")
    print_json(listRequest)
    try:
        listUrl = listResource.create_list(listRequest)
        print("Fetching New List...")
        newList = listResource.get_by_resource_uri(listUrl)
        print("------ New List ------")
        print_json(newList)
    except ApifonRestError as x:
        print("Apifon Rest Error while trying to create Simple List:\n" + str(x))



def get_client_credentials_grant_configuration(clientId, clientSecret):
    return OAuthConfigurationBuilder.get_client_credentials_builder(clientId, clientSecret).build()


def client_credentials_grant_example():
    """
    this example sets one token for reading and writing lists. This token is associated with an identifier for easier
    organization. Identifiers can be anything you wish. After setting the tokens you have permission to create and
    retrieve lists. The example concludes with the revocation of the token.
    """

    oauth_config_list = get_client_credentials_grant_configuration(client_id, client_secret)
    # Setting the OAuth configurations to Mookee instances
    Mookee.add_oauth_resource(oauth_identifier_list, oauth_config_list)
    # Retrieve an OAuth2 tokens from the Identity server using the configurations.
    Mookee.retrieve_client_credentials_token(oauth_identifier_list)
    # Setting the Mookee to OAuth mode so that OAuth is used for any subsequent API calls.
    Mookee.set_mookee_to_oauth_mode(oauth_identifier_list, True)
    # Call API to create List
    create_simple_list()
    # Remove the tokens.Setting the second parameter to True also revokes (permanently deletes) the tokens,
    # which means that you'll need to request new ones
    Mookee.remove_oauth_resource(oauth_identifier_list, True)


try:
    client_credentials_grant_example()
except ApifonRestError as x:
    print(str(x))
