class ApifonRestError(IOError):
    def __init__(self, response=None, io_error=None):
        super().__init__(io_error)
        self.response = response

    def __str__(self):
        if self.response is not None:
            error_details = ""
            for k, v in self.response.error_details.items():
                error_details += k + ': ' + v + '\n'

            return 'Status: ' + str(self.response.status) + '\n' + \
                   'Title: ' + self.response.title + '\n' + \
                   'Error details: ' + error_details + '\n' + \
                   'Error code: ' + self.response.error_report_code
        else:
            return super().__str__()
