from Apifon.sdk.Exception.OAuthError import OAuthError


class OAuthTokenError(OAuthError):

    def __init__(self, message = None, httpResponse = None):
        super().__init__(message)
        self.response = httpResponse

    def __str__(self):
        if self.response is not None:
            status = 400
            if self.response.error.lower() == "invalid_client":
                status = 401

            return 'Title: Unauthorised'\
                   'Status: ' + str(status) + '\n' + \
                   'Error: ' + self.response.error + '\n' + \
                   'Error description: ' + self.response.error_description + '\n'

        else:
            return super().__str__()
