from abc import ABCMeta, abstractmethod
from urllib import parse


class AbstractFieldSerializable(metaclass=ABCMeta):

    @abstractmethod
    def add_visible_fields(self, fields):
        raise NotImplementedError

    @abstractmethod
    def add_visible_field(self, fields):
        raise NotImplementedError

    def get_query_params(self):
        field_string = ""
        if self.get_fields() is not None and bool(self.get_fields()):
            field_string = '?fields=' + parse.quote(','.join(self.get_fields()))
        return field_string

    @abstractmethod
    def get_fields(self):
        raise NotImplementedError

    @abstractmethod
    def get_path_id(self):
        raise NotImplementedError
