from datetime import datetime

from Apifon.sdk.Model.SingleResponse import SingleResponse
from Apifon.sdk.Model.SubscriberGdprField import SubscriberGdprField


class SubscriberResponse(SingleResponse):
    def __init__(self, array_values = None):
        super().__init__(array_values)
        self.id = None
        self.account_id = None
        self.destination = None
        self.destination_id = None
        self.email_id = None
        self.email = None
        self.date_created = None
        self.date_updated = None
        self.list_id = None
        self.status = None
        self.email_status = None
        self.gdpr_fields = {}
        self.subscriber_fields = {}
        self.groupOptions = []
        self.assign_values(array_values)

    def assign_values(self, array_values):
        if array_values is not None:
            if 'id' in array_values:
                self.id = array_values['id']
            if 'account_id' in array_values:
                self.account_id = array_values['account_id']
            if 'destination' in array_values:
                self.destination = array_values['destination']
            if 'destination_id' in array_values:
                self.destination_id = array_values['destination_id']
            if 'email_id' in array_values:
                self.email_id = array_values['email_id']
            if 'email' in array_values:
                self.email = array_values['email']
            if 'date_created' in array_values:
                self.date_created = datetime.fromtimestamp(int(array_values['date_created'])/1000).strftime('%c')
            if 'date_updated' in array_values:
                self.date_updated = datetime.fromtimestamp(int(array_values['date_updated'])/1000).strftime('%c')
            if 'list_id' in array_values:
                self.list_id = array_values['list_id']
            if 'status' in array_values:
                self.status = array_values['status']
            if 'email_status' in array_values:
                self.email_status = array_values['email_status']
            if 'gdpr_fields' in array_values and bool(array_values['gdpr_fields']):
                for k, v in array_values['gdpr_fields'].items():
                    self.gdpr_fields[k] = SubscriberGdprField(v)
            if 'subscriber_fields' in array_values and bool(array_values['subscriber_fields']):
                for k, v in array_values['subscriber_fields'].items():
                    self.subscriber_fields[k] = v
            if 'groupOptions' in array_values:
                for result in array_values['groupOptions']:
                    self.groupOptions.append(result)